---
title: Handshake Improvement Proposals
description: 
published: 1
date: 2024-02-09T04:02:44.100Z
tags: 
editor: markdown
dateCreated: 2024-02-09T04:02:44.100Z
---

# Handshake Improvement Proposals

"A Handshake Improvement Proposal is a technical document that attempts to standardize a feature or protocol extension across the Handshake ecosystem. It should be implementation-agnostic. If you would like to propose a specific change to `hsd` or `hnsd`, open an issue or pull request in the appropriate repository. HIPs are not consensus, they are not law, they may never be actually implemented in production. HIPs are just solutions to common problems that the Handshake developer community can use as reference in their own projects. They may change over time, or be replaced with newer HIPs." - [HNS-Dev.org](https://hsd-dev.org/HIPs/)


## HIP-0 HIP Template
The meta on proposing HIPs

[https://hsd-dev.org/HIPs/proposals/0000/](https://hsd-dev.org/HIPs/proposals/0000/)
Author: [falci/](http://falci)

## HIP-1 Non-Interactive Atomic Name Swaps
Describing a way to sell TLDs onchain without knowing your counter party beforehand. HIP-1 is what Shakedex is based on.


[https://hsd-dev.org/HIPs/proposals/0001/](https://hsd-dev.org/HIPs/proposals/0001/)
Author: Mark Tyneway

## HIP-2 Well Known Wallets
Allow domain owners to attach crypto-wallet addresses to their TLDs using e.g. [falci/.well-known/BTC](https://falci/.well-known/BTC) for you Bitcoin address.


[https://hsd-dev.org/HIPs/proposals/0002/](https://hsd-dev.org/HIPs/proposals/0002/)
Author: [falci/](http://falci)

## HIP-4 Interactive Atomic Name Swaps
Allow predefined counterparties to trade a TLD onchain at a predfined price


[https://hsd-dev.org/HIPs/proposals/0004/](https://hsd-dev.org/HIPs/proposals/0004/)
Author: [pinheadmz/](http://pinheadmz)

## HIP-5 Alternative Namespace Resolution
Create a standard for hosting zone data at other locations not on at an IP address. The first implementation is for `_eth` which allows ENS on Ethereum to manage DNS records for Handshake TLDs like [.badass/](https://medium.com/@ca98am79/introducing-badass-domains-4d90bd48108b)




[https://hsd-dev.org/HIPs/proposals/0005/](https://hsd-dev.org/HIPs/proposals/0005/)
Author: [carson/](http://carson), [pinheadmz/](http://pinheadmz)

